define({
    'name' : 'MaMPOK',
    'sub-menu' : [
        {
            'name' : 'Documentation',
            'external-link' : 'https://github.molgen.mpg.de/loosolab/MaMPOK',
        },
        '---',
        {
            'name' : 'Create MaMplan for CellxGene deployment',
            'type': 'code',
            'snippet' : [
                '# Unique experiment ID',
                'id = \'\'',
                'organization = \'\'', 
                '',
                '# Path to store object and MaMplan',
                'outpath = \'/mnt/agnerds/DEPLOYMENTS2/\'',
                '',
                'import re',
                'import yaml',
                'import os',
                '',
                'maplan_tamplate = {\'container\':{\'main\':{\'extra_args\':[\'-t\',id]}},\'deployment\': {\'active\': True, \'bucket\': \'\',',
                '    \'replicas\': 1, \'url\': \'\'}, ',
                '    \'project\': {\'id\': \'\', \'init_container\': \'s3download\', \'supress_s3\': False, \'tool\': \'cellxgene\'},',
                '    \'tags\':{\'organization\':organization}}',
                'maplan_tamplate[\'deployment\'][\'bucket\'] = \'mampok-\' + id + \'-cellxgene\'',
                '',
                '#Check if bucket name is valid',
                'if not re.match(r"(?=^.{3,63}$)(?!^(\\d+\\.)+\\d+$)(^(([a-z0-9]|[a-z0-9][a-z0-9\\-]*[a-z0-9])\\.)*([a-z0-9]|[a-z0-9][a-z0-9\\-]*[a-z0-9])$)", id):',
                '    raise Exception(\'ERROR! \\\'{}\\\' is not a valid name for a S3 bucket. It must be between 3 and 63 characters long and may not contain \\\'_\\\' or \\\'.\\\'.\'.format(id))',
                '',
                'maplan_tamplate[\'deployment\'][\'url\'] = \'mpibn.mampok.ingress.rancher.computational.bio/\' + id + \'/cellxgene\'',
                'maplan_tamplate[\'project\'][\'files\']  = [\'{id}-cellxgene.h5ad\'.format(id=id)]',
                'maplan_tamplate[\'project\'][\'id\'] = id' ,
                '',
                '#write MaMPlan and check for existing file',
                'mamplanpath = outpath + id + \'_MaMPlan.yaml\'',
                'if os.path.exists(mamplanpath):',
                '    raise Exception(\'ERROR! A MaMplan \\\'{}\\\' already exists!\'.format(mamplanpath))',
                '',
                'with open(mamplanpath, \'w\') as f:',
                '    yaml.dump(maplan_tamplate, f)',
                'print(\'Wrote MaMplan to: \\\'{}\\\'\'.format(mamplanpath))',

                '# Save anndata object',
                'adata.write(outpath + \'{id}-cellxgene.h5ad\'.format(id=id))'
            ],
        }
    ],
});
